<script setup>
import { CdxField, CdxTextInput, CdxSelect } from '@wikimedia/codex';
import { useInstrumentStore } from '../../stores/instrument.js';

const instrumentStore = useInstrumentStore();

const variantTypeMenuItems = [
    { label: 'Boolean', value: 'boolean', description: "Only takes 'true' or 'false' as values" }
];

function onTypeSelected() {
    instrumentStore.instrument.variants[0].values = 'true,false'
}
</script>

<template>
    <h2>Variants</h2>
    <!-- VARIANTS -->
    <cdx-field>
        <template #label>
            Feature variants
        </template>
        <template #description>
            Define which parameters of your feature will be tested
        </template>
        <div class="field-group">
            <div class="column-2">
                <div class="column">
                    <cdx-field class="smaller-column">
                        <cdx-text-input
                            v-model="instrumentStore.instrument.variants[0].name"
                            :readonly="instrumentStore.isActivatedABTest"
                            data-id="variant-name"
                            v-tooltip="instrumentStore.activatedABTooltip"
                        />
                        <template #label>
                            Parameter
                        </template>
                    </cdx-field>
                </div>
                <div class="column right">
                    <cdx-field>
                        <cdx-select
                            v-model:selected="instrumentStore.instrument.variants[0].type"
                            :disabled="instrumentStore.isActivatedABTest"
                            :menu-items="variantTypeMenuItems"
                            default-label="Select type..."
                            data-id="variant-type"
                            @update:selected="onTypeSelected"
                            v-tooltip="instrumentStore.activatedABTooltip"
                        />
                        <template #label>
                            Type
                        </template>
                    </cdx-field>
                </div>
            </div>
            <div class="clearfix"></div>
            <cdx-field class="smaller-column">
                <cdx-text-input class="smaller-column"
                    v-model="instrumentStore.instrument.variants[0].values"
                    :readonly="instrumentStore.isActivatedABTest"
                    data-id="variant-values"
                    v-tooltip="instrumentStore.activatedABTooltip"
                />
                <template #label>
                    Values
                </template>
                <template #description>
                    Enter a single value or multiple values separated by commas
                </template>
            </cdx-field>
        </div>
    </cdx-field>
</template>

<style scoped>
.contextual-attributes {
    margin-top: 20px;
}
.smaller-column {
    width: 300px;
}
</style>
